using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
	public class CarMod : MonoBehaviour
	{
		public static void Main()
		{
            CategoryBuilder.Create("Bangee Cars", "<color=green>My cars :D", ModAPI.LoadSprite("Cars/view.png"));

		ModAPI.Register(
	 new Modification()
	 {
		OriginalItem = ModAPI.FindSpawnable("Car"),
		NameOverride = "Mercedes Maybach",
		NameToOrderByOverride = "!",
		DescriptionOverride = "Wow, it's <color=red>very cool",
		CategoryOverride = ModAPI.FindCategory("Bangee Cars"),
		ThumbnailOverride = ModAPI.LoadSprite("Cars/Maybach/Thumb.png"),
		AfterSpawn = (Instance) =>
		{
		        Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
					Instance.transform.Find("Bonnet").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Cars/Maybach/Bonnet.png"),
                                };
			Instance.transform.Find("Boot").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Cars/Maybach/Boot.png"),
                                };
			Instance.transform.Find("FrontDoor").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Cars/Maybach/FrontDoor.png"),
                                };
			Instance.transform.Find("BackDoor").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Cars/Maybach/BackDoor.png"),
                                };
                        Instance.transform.Find("Body").Find("CarBodyBackground").gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cars/Maybach/Backgrond.png");

	Instance.transform.Find("Body").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Cars/Maybach/Boby.png"),
                                };
								
						var childObject = new GameObject("glow");
                        childObject.transform.SetParent(Instance.transform.Find("Body"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
						
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("Far.png");
                        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");

						var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
					
						foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }


			   }
		  }
	     );
	}
    }
}

